/*
    Tesses.ProfileIcon A profile Icon Generator
    Copyright (C) 2023  Mike Nolan

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace Tesses.ProfileIcon
{
    public delegate int ProfileIconColorPickerDelegate(ProfileIconCreator creator,string text);
    public abstract class ProfileIconColorPicker
    {
        internal static ProfileIconColorPicker FromDelegate(ProfileIconColorPickerDelegate del)
        {
            return new ProfileIconColorPickerDelegateObj(del);
        }
        public abstract int GetColor(ProfileIconCreator creator,string text);

        private class ProfileIconColorPickerDelegateObj : ProfileIconColorPicker
        {
            private ProfileIconColorPickerDelegate del;

            public ProfileIconColorPickerDelegateObj(ProfileIconColorPickerDelegate del)
            {
                this.del = del;
            }

            public override int GetColor(ProfileIconCreator creator, string text)
            {
                if(del == null) return 0;
                return del(creator,text);
            }
        }
    }
}